Index: code/trunk/src/network/packet/Packet.h
===================================================================
--- code/trunk/src/network/packet/Packet.h	(revision 1937)
+++ code/trunk/src/network/packet/Packet.h	(revision 2087)
@@ -29,4 +29,6 @@
 #define NETWORKPACKET_H
 
+#include "../NetworkPrereqs.h"
+
 #include <map>
 #include <enet/enet.h>
@@ -37,5 +39,5 @@
 
 namespace packet{
-  
+
 namespace ENUM{
   enum Direction{
@@ -53,9 +55,9 @@
   };
 }
-  
+
 /**
 	@author Oliver Scheuss <scheusso [at] ee.ethz.ch>
 */
-class Packet{
+class _NetworkExport Packet{
   public:
     Packet(const Packet &p);
@@ -63,5 +65,5 @@
     static Packet *createPacket(ENetPacket *packet, ENetPeer *peer);
     static void deletePacket(ENetPacket *packet);
-    
+
     virtual unsigned char *getData(){ return data_; };
     virtual unsigned int getSize() const =0;
@@ -73,5 +75,5 @@
     void setClientID( int id )
       { clientID_ = id; }
-    
+
     bool send();
   protected:
@@ -82,5 +84,11 @@
     unsigned int clientID_;
     ENUM::Direction packetDirection_;
+    /** Pointer to the data. Be careful when deleting it because it might
+        point to a location that was allocated by ENet.
+        See bDataENetAllocated_ */
     uint8_t *data_;
+    /** Tells whether data_ was allocated by ENet or ourselves.
+        data_ might no correlate with enetPacket_->data. */
+    bool bDataENetAllocated_;
   private:
     static std::map<ENetPacket *, Packet *> packetMap_;
Index: code/trunk/src/network/packet/Welcome.h
===================================================================
--- code/trunk/src/network/packet/Welcome.h	(revision 1937)
+++ code/trunk/src/network/packet/Welcome.h	(revision 2087)
@@ -29,4 +29,6 @@
 #define NETWORKWELCOME_H
 
+#include "../NetworkPrereqs.h"
+
 #include "Packet.h"
 
@@ -35,7 +37,7 @@
 
 /**
-	@author 
+	@author
 */
-class Welcome : public Packet
+class _NetworkExport Welcome : public Packet
 {
 public:
@@ -43,9 +45,9 @@
   Welcome( uint8_t* data, unsigned int clientID );
   virtual ~Welcome();
-  
+
   uint8_t *getData();
   inline unsigned int getSize() const;
   bool process();
-  
+
 private:
 };
Index: code/trunk/src/orxonox/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/CMakeLists.txt	(revision 1937)
+++ code/trunk/src/orxonox/CMakeLists.txt	(revision 2087)
@@ -1,7 +1,8 @@
 SET( ORXONOX_SRC_FILES
+  CameraManager.cc
   GraphicsEngine.cc
+  LevelManager.cc
   Main.cc
   Settings.cc
-  SignalHandler.cc
 
   gamestates/GSClient.cc
@@ -33,7 +34,7 @@
   overlays/hud/HUDRadar.cc
   overlays/hud/HUDSpeedBar.cc
+  overlays/hud/ChatOverlay.cc
 
   tools/BillboardSet.cc
-  tools/Light.cc
   tools/Mesh.cc
   tools/ParticleInterface.cc
@@ -42,24 +43,47 @@
   tools/WindowEventListener.cc
 
-  objects/Ambient.cc
-  objects/Backlight.cc
-  objects/Camera.cc
-  objects/CameraHandler.cc
-  objects/Model.cc
-  objects/NPC.cc
-  objects/ParticleSpawner.cc
+  objects/EventListener.cc
+  objects/EventDispatcher.cc
+  objects/EventTarget.cc
   objects/Radar.cc
   objects/RadarListener.cc
   objects/RadarViewable.cc
-  objects/Skybox.cc
-  objects/SpaceShip.cc
-  objects/SpaceShipAI.cc
   objects/Tickable.cc
-  objects/WorldEntity.cc
+  objects/Test.cc
+  objects/Script.cc
 
-  objects/Projectile.cc
-  objects/BillboardProjectile.cc
-  objects/RotatingProjectile.cc
-  objects/ParticleProjectile.cc
+  objects/Scene.cc
+  objects/worldentities/WorldEntity.cc
+  objects/worldentities/PositionableEntity.cc
+  objects/worldentities/MovableEntity.cc
+  objects/worldentities/ControllableEntity.cc
+  objects/worldentities/Model.cc
+  objects/worldentities/Billboard.cc
+  objects/worldentities/BlinkingBillboard.cc
+  objects/worldentities/Light.cc
+  objects/worldentities/Camera.cc
+  objects/worldentities/CameraPosition.cc
+  objects/worldentities/SpawnPoint.cc
+  objects/worldentities/ParticleEmitter.cc
+  objects/worldentities/ParticleSpawner.cc
+#  objects/worldentities/Backlight.cc
+
+  objects/worldentities/triggers/Trigger.cc
+  objects/worldentities/triggers/DistanceTrigger.cc
+  objects/worldentities/triggers/EventTrigger.cc
+
+  objects/worldentities/pawns/Spectator.cc
+  objects/worldentities/pawns/Pawn.cc
+  objects/worldentities/pawns/SpaceShip.cc
+
+  objects/controllers/Controller.cc
+  objects/controllers/HumanController.cc
+
+  objects/infos/Info.cc
+  objects/infos/Level.cc
+  objects/infos/PlayerInfo.cc
+  objects/infos/HumanPlayer.cc
+
+  objects/gametypes/Gametype.cc
 
   tolua/tolua_bind.cc
@@ -76,5 +100,6 @@
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/bin/lib
 )
-	
+
+
 ADD_EXECUTABLE( orxonox ${ORXONOX_SRC_FILES} )
 
@@ -83,14 +108,6 @@
   SET( ORXONOXS_SRC_FILES
     GraphicsEngine.cc
-    objects/Ambient.cc
     objects/Camera.cc
-    objects/CameraHandler.cc
-    objects/Explosion.cc
-    objects/Model.cc
-    objects/NPC.cc
-    objects/Projectile.cc
-    objects/Skybox.cc
-    objects/SpaceShip.cc
-    objects/WorldEntity.cc
+    CameraManager.cc
   )
 
Index: code/trunk/src/orxonox/CameraManager.cc
===================================================================
--- code/trunk/src/orxonox/CameraManager.cc	(revision 2087)
+++ code/trunk/src/orxonox/CameraManager.cc	(revision 2087)
@@ -0,0 +1,103 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Benjamin Knecht
+ *   Co-authors:
+ *      Fabian 'x3n' Landau
+ *
+ */
+#include "OrxonoxStableHeaders.h"
+#include "CameraManager.h"
+
+#include <OgreViewport.h>
+
+#include "core/Core.h"
+#include "objects/worldentities/Camera.h"
+
+
+namespace orxonox
+{
+    CameraManager* CameraManager::singletonRef_s = 0;
+
+    CameraManager::CameraManager(Ogre::Viewport* viewport)
+        : viewport_(viewport)
+    {
+        assert(singletonRef_s == 0);
+        singletonRef_s = this;
+    }
+
+    CameraManager::~CameraManager()
+    {
+        assert(singletonRef_s != 0);
+        singletonRef_s = 0;
+    }
+
+    Camera* CameraManager::getActiveCamera() const
+    {
+        if (this->cameraList_.size() > 0)
+            return this->cameraList_.front();
+        else
+            return 0;
+    }
+
+    void CameraManager::requestFocus(Camera* camera)
+    {
+        if (!Core::showsGraphics())
+            return;
+
+        // notify old camera (if it exists)
+        if (this->cameraList_.size() > 0)
+            this->cameraList_.front()->removeFocus();
+
+        camera->setFocus(this->viewport_);
+
+        // add to list
+        std::list<Camera*>::iterator it;
+        for (it = this->cameraList_.begin(); it != this->cameraList_.end(); ++it)
+        {
+            if ((*it) == camera)
+                return; // make sure we don't add it twice
+        }
+        this->cameraList_.push_front(camera);
+    }
+
+    void CameraManager::releaseFocus(Camera* camera)
+    {
+        if (!Core::showsGraphics())
+            return;
+
+        // notify the cam of releasing the focus
+        if (this->cameraList_.front() == camera)
+        {
+            camera->removeFocus();
+            this->cameraList_.pop_front();
+
+            // set new focus if necessary
+            if (cameraList_.size() > 0)
+                cameraList_.front()->setFocus(this->viewport_);
+        }
+        else
+        {
+            this->cameraList_.remove(camera);
+        }
+    }
+}
Index: code/trunk/src/orxonox/CameraManager.h
===================================================================
--- code/trunk/src/orxonox/CameraManager.h	(revision 2087)
+++ code/trunk/src/orxonox/CameraManager.h	(revision 2087)
@@ -0,0 +1,69 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Benjamin Knecht
+ *   Co-authors:
+ *      Fabian 'x3n' Landau
+ *
+ */
+
+ /**
+ @file  CameraManager.h
+ @brief Handles the instances of Camera class
+ @author Benjamin Knecht <beni_at_orxonox.net>
+  */
+
+#ifndef _CameraManager_H__
+#define _CameraManager_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <cassert>
+#include <list>
+#include <OgrePrerequisites.h>
+
+namespace orxonox
+{
+    class _OrxonoxExport CameraManager
+    {
+        public:
+            CameraManager(Ogre::Viewport* viewport);
+            ~CameraManager();
+
+            Camera* getActiveCamera() const;
+
+            void requestFocus(Camera* camera);
+            void releaseFocus(Camera* camera);
+
+            static CameraManager& getInstance() { assert(singletonRef_s); return *singletonRef_s; }
+
+        private:
+            CameraManager(const CameraManager&);
+
+            std::list<Camera*> cameraList_;
+            Ogre::Viewport* viewport_;
+
+            static CameraManager* singletonRef_s;
+    };
+}
+
+#endif /* _CameraManager_H__ */
Index: code/trunk/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/trunk/src/orxonox/GraphicsEngine.cc	(revision 1937)
+++ code/trunk/src/orxonox/GraphicsEngine.cc	(revision 2087)
@@ -68,8 +68,7 @@
     */
     GraphicsEngine::GraphicsEngine()
-        : root_(0)
-        , renderWindow_(0)
-        , levelSceneManager_(0)
-        , viewport_(0)
+//        : root_(0)
+//        , renderWindow_(0)
+//        , viewport_(0)
     {
         RegisterObject(GraphicsEngine);
@@ -103,45 +102,3 @@
         singletonRef_s = 0;
     }
-
-    /**
-    @brief
-        Get the width of the render window
-    @return
-        The width of the render window
-    */
-    int GraphicsEngine::getWindowWidth() const
-    {
-        if (this->renderWindow_)
-            return this->renderWindow_->getWidth();
-        else
-            return 0;
-    }
-
-    /**
-    @brief
-        Get the height of the render window
-    @return
-        The height of the render window
-    */
-    int GraphicsEngine::getWindowHeight() const
-    {
-        if (this->renderWindow_)
-            return this->renderWindow_->getHeight();
-        else
-            return 0;
-    }
-
-    /**
-    @brief
-        Returns the window aspect ratio height/width.
-    @return
-        The window aspect ratio
-    */
-    float GraphicsEngine::getWindowAspectRatio() const
-    {
-        if (this->renderWindow_)
-            return (float)this->renderWindow_->getHeight() / (float)this->renderWindow_->getWidth();
-        else
-            return 1.0f;
-    }
 }
Index: code/trunk/src/orxonox/GraphicsEngine.h
===================================================================
--- code/trunk/src/orxonox/GraphicsEngine.h	(revision 1937)
+++ code/trunk/src/orxonox/GraphicsEngine.h	(revision 2087)
@@ -61,14 +61,4 @@
         void detailLevelParticleChanged();
 
-        void setLevelSceneManager(Ogre::SceneManager* sceneMgr) { this->levelSceneManager_ = sceneMgr; }
-        Ogre::SceneManager* getLevelSceneManager() { return levelSceneManager_; }
-
-        Ogre::Viewport* getViewport() { return this->viewport_; }
-        Ogre::Root*     getOgreRoot() { return this->root_; }
-
-        // several window properties
-        int getWindowWidth() const;
-        int getWindowHeight() const;
-        float getWindowAspectRatio() const;
         float getAverageFramesPerSecond() const   { return this->avgFramesPerSecond_; }
         float getAverageTickTime() const          { return this->avgTickTime_; }
@@ -86,9 +76,4 @@
         GraphicsEngine(GraphicsEngine&);
 
-        Ogre::Root*         root_;                  //!< Ogre's root
-        Ogre::RenderWindow* renderWindow_;          //!< the current render window
-        Ogre::SceneManager* levelSceneManager_;     //!< scene manager of the game
-        Ogre::Viewport*     viewport_;              //!< default full size viewport
-
         // stats
         float               avgTickTime_;           //!< time in ms to tick() one frame
Index: code/trunk/src/orxonox/LevelManager.cc
===================================================================
--- code/trunk/src/orxonox/LevelManager.cc	(revision 2087)
+++ code/trunk/src/orxonox/LevelManager.cc	(revision 2087)
@@ -0,0 +1,144 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+
+#include "LevelManager.h"
+
+#include "core/CoreIncludes.h"
+
+#include "objects/infos/Level.h"
+#include "objects/infos/HumanPlayer.h"
+
+namespace orxonox
+{
+    LevelManager* LevelManager::singletonRef_s = 0;
+
+    LevelManager::LevelManager()
+    {
+        RegisterRootObject(LevelManager);
+
+        assert(singletonRef_s == 0);
+        singletonRef_s = this;
+
+        this->getConnectedClients();
+    }
+
+    LevelManager::~LevelManager()
+    {
+        assert(singletonRef_s != 0);
+        singletonRef_s = 0;
+    }
+
+    void LevelManager::requestActivity(Level* level)
+    {
+        this->levels_s.push_back(level);
+        if (this->levels_s.size() == 1)
+            this->activateNextLevel();
+    }
+
+    void LevelManager::releaseActivity(Level* level)
+    {
+        if (this->levels_s.size() > 0)
+        {
+            if (this->levels_s.front() == level)
+            {
+                level->setActive(false);
+                this->levels_s.pop_front();
+                this->activateNextLevel();
+            }
+            else
+            {
+                for (std::list<Level*>::iterator it = this->levels_s.begin(); it != this->levels_s.end(); ++it)
+                    if ((*it) == level)
+                        this->levels_s.erase(it);
+            }
+        }
+    }
+
+    Level* LevelManager::getActiveLevel()
+    {
+        if (this->levels_s.size() > 0)
+            return this->levels_s.front();
+        else
+            return 0;
+    }
+
+    void LevelManager::activateNextLevel()
+    {
+        if (this->levels_s.size() > 0)
+        {
+            this->levels_s.front()->setActive(true);
+            for (std::map<unsigned int, PlayerInfo*>::iterator it = this->clients_.begin(); it != this->clients_.end(); ++it)
+                this->levels_s.front()->playerEntered(it->second);
+        }
+    }
+
+
+    void LevelManager::clientConnected(unsigned int clientID)
+    {
+        COUT(3) << "client connected" << std::endl;
+
+        // create new HumanPlayer instance
+        HumanPlayer* player = new HumanPlayer(0);
+        player->setClientID(clientID);
+
+        // add to clients-map
+        assert(!this->clients_[clientID]);
+        this->clients_[clientID] = player;
+
+        if (this->getActiveLevel())
+            this->getActiveLevel()->playerEntered(player);
+    }
+
+    void LevelManager::clientDisconnected(unsigned int clientID)
+    {
+        COUT(3) << "client disconnected" << std::endl;
+
+        // remove from clients-map
+        PlayerInfo* player = this->clients_[clientID];
+        this->clients_.erase(clientID);
+
+        if (this->getActiveLevel())
+            this->getActiveLevel()->playerLeft(player);
+
+        // delete PlayerInfo instance
+        if (player)
+            delete player;
+    }
+
+
+    PlayerInfo* LevelManager::getClient(unsigned int clientID) const
+    {
+        std::map<unsigned int, PlayerInfo*>::const_iterator it = this->clients_.find(clientID);
+        if (it != this->clients_.end())
+            return it->second;
+        else
+            return 0;
+    }
+}
Index: code/trunk/src/orxonox/LevelManager.h
===================================================================
--- code/trunk/src/orxonox/LevelManager.h	(revision 2087)
+++ code/trunk/src/orxonox/LevelManager.h	(revision 2087)
@@ -0,0 +1,73 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _LevelManager_H__
+#define _LevelManager_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <list>
+#include <map>
+#include <cassert>
+
+#include "network/ClientConnectionListener.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport LevelManager : public network::ClientConnectionListener
+    {
+        public:
+            LevelManager();
+            virtual ~LevelManager();
+
+            void requestActivity(Level* level);
+            void releaseActivity(Level* level);
+            Level* getActiveLevel();
+
+            PlayerInfo* getClient(unsigned int clientID) const;
+            inline const std::map<unsigned int, PlayerInfo*>& getClients() const
+                { return this->clients_; }
+
+            static LevelManager& getInstance() { assert(singletonRef_s); return *singletonRef_s; }
+
+        private:
+            LevelManager(const LevelManager&);
+
+            void clientConnected(unsigned int clientID);
+            void clientDisconnected(unsigned int clientID);
+
+            void activateNextLevel();
+
+            std::list<Level*> levels_s;
+            std::map<unsigned int, PlayerInfo*> clients_;
+
+            static LevelManager* singletonRef_s;
+    };
+}
+
+#endif /* _LevelManager_H__ */
Index: code/trunk/src/orxonox/Main.cc
===================================================================
--- code/trunk/src/orxonox/Main.cc	(revision 1937)
+++ code/trunk/src/orxonox/Main.cc	(revision 2087)
@@ -40,6 +40,6 @@
 #include "util/OrxonoxPlatform.h"
 #include "util/Debug.h"
+#include "util/SignalHandler.h"
 #include "core/ConfigFileManager.h"
-#include "SignalHandler.h"
 
 #include "gamestates/GSRoot.h"
Index: code/trunk/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxPrereqs.h	(revision 1937)
+++ code/trunk/src/orxonox/OrxonoxPrereqs.h	(revision 2087)
@@ -80,20 +80,51 @@
     class RadarListener;
 
+    class CameraManager;
+    class LevelManager;
+
     // objects
-    class Ambient;
+    class Scene;
+
+    class WorldEntity;
+    class PositionableEntity;
+    class MovableEntity;
+    class ControllableEntity;
+    class Sublevel;
+
+    class Model;
+    class Billboard;
+    class BlinkingBillboard;
+    class Light;
     class Backlight;
+    class ParticleEmitter;
+    class ParticleSpawner;
+
     class Camera;
-    class Model;
-    class NPC;
-    class ParticleSpawner;
-    class Skybox;
+    class CameraPosition;
+    class SpawnPoint;
+
+    class Spectator;
+    class Pawn;
     class SpaceShip;
-    class SpaceShipAI;
-    class WorldEntity;
 
-    class Projectile;
-    class BillboardProjectile;
-    class RotatingProjectile;
-    class ParticleProjectile;
+    class Trigger;
+    class DistanceTrigger;
+    class EventTrigger;
+
+    class EventListener;
+    class EventDispatcher;
+    class EventTarget;
+
+    class Controller;
+    class HumanController;
+
+    class Info;
+    class Level;
+    class PlayerInfo;
+    class HumanPlayer;
+
+    class Gametype;
+
+    class Scores;
 
     // tools
Index: code/trunk/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 1937)
+++ code/trunk/src/orxonox/OrxonoxStableHeaders.h	(revision 2087)
@@ -37,5 +37,5 @@
 #include "util/OrxonoxPlatform.h"
 
-#if ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC && !defined(ORXONOX_DISABLE_PCH)
+#if defined(ORXONOX_ENABLE_PCH)
 
 // including std headers here is useless since they're already precompiled
@@ -47,13 +47,15 @@
 #include <Ogre.h>
 #include <CEGUI.h>
+#include "ois/OIS.h"
 #include <boost/thread/recursive_mutex.hpp>
-#include <boost/thread/mutex.hpp>
-#include <boost/thread/condition.hpp>
-#include <boost/thread/thread.hpp>
-
+//#include <boost/thread/mutex.hpp>
+//#include <boost/thread/condition.hpp>
+//#include <boost/thread/thread.hpp>
+#include <boost/static_assert.hpp>
 #include "tinyxml/ticpp.h"
 #include "tinyxml/tinyxml.h"
+#include "tolua/tolua++.h"
 
-//Get around Windows hackery (windows.h is included by Ogre)
+//Get around Windows hackery (windows.h is included by Ogre.h)
 #if ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32 
 #  ifdef max
@@ -67,13 +69,12 @@
 //----------- Our files ----------
 //--------------------------------
-// only include when not debugging so that we may find issues with missing headers quicker
-#if defined(NDEBUG)
+//// only include when not debugging so that we may find issues with missing headers quicker
+//#if defined(NDEBUG)
 
 #include "util/Convert.h"
 #include "util/Debug.h"
+#include "util/Exception.h"
 #include "util/Math.h"
 #include "util/Multitype.h"
-#include "util/OutputBuffer.h"
-#include "util/OutputHandler.h"
 #include "util/Sleep.h"
 #include "util/String.h"
@@ -85,17 +86,18 @@
 #include "core/ConfigValueIncludes.h"
 #include "core/CommandExecutor.h"
+#include "core/Core.h"
 #include "core/Executor.h"
+#include "core/ObjectList.h"
+#include "core/Super.h"
 #include "core/XMLIncludes.h"
 #include "core/XMLPort.h"
+#include "core/input/SimpleInputState.h"
+#include "core/input/InputManager.h"
 
 #include "network/Synchronisable.h"
 
-//#include "tools/Mesh.h"
-//#include "tools/Timer.h"
-//#include "objects/Model.h"
-//#include "objects/Tickable.h"
-//#include "objects/WorldEntity.h"
+#include "Settings.h"
 
-#endif /* ifdef NDEBUG */
+//#endif /* ifdef NDEBUG */
 
 #endif /* ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC && !defined(ORXONOX_DISABLE_PCH) */
Index: code/trunk/src/orxonox/Settings.cc
===================================================================
--- code/trunk/src/orxonox/Settings.cc	(revision 1937)
+++ code/trunk/src/orxonox/Settings.cc	(revision 2087)
@@ -39,4 +39,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
+#include "core/LuaBind.h"
 
 namespace orxonox
@@ -49,7 +50,4 @@
     */
     Settings::Settings()
-        : bShowsGraphics_(false)
-        , bHasServer_(false)
-        , bIsClient_(false)
     {
         RegisterRootObject(Settings);
@@ -65,5 +63,5 @@
     void Settings::setConfigValues()
     {
-        SetConfigValue(dataPath_, "../../Media/").description("Relative path to the game data.").callback(this, &Settings::dataPathChanged);
+        SetConfigValue(dataPath_, "../../media/").description("Relative path to the game data.").callback(this, &Settings::dataPathChanged);
     }
 
@@ -84,4 +82,6 @@
             COUT(2) << "Warning: Data path set to \"/\", is that really correct?" << std::endl;
         }
+
+        LuaBind::getInstance()->setIncludePath(this->dataPath_);
     }
 
Index: code/trunk/src/orxonox/Settings.h
===================================================================
--- code/trunk/src/orxonox/Settings.h	(revision 1937)
+++ code/trunk/src/orxonox/Settings.h	(revision 2087)
@@ -50,8 +50,4 @@
         friend class ClassIdentifier<Settings>;
         friend class GSRoot;
-        friend class GSGraphics;
-        friend class GSServer;
-        friend class GSClient;
-        friend class GSDedicated;
 
     public:
@@ -61,15 +57,5 @@
         { assert(singletonRef_s); singletonRef_s->_tsetDataPath(path); }
 
-        // an alternative to a global game mode variable
-        static bool showsGraphics() { assert(singletonRef_s); return singletonRef_s->bShowsGraphics_; }
-        static bool hasServer()     { assert(singletonRef_s); return singletonRef_s->bHasServer_; }
-        static bool isClient()      { assert(singletonRef_s); return singletonRef_s->bIsClient_; }
-
     private:
-        // GSRoot has access to these
-        static void setShowsGraphics(bool val) { assert(singletonRef_s); singletonRef_s->bShowsGraphics_ = val; }
-        static void setHasServer    (bool val) { assert(singletonRef_s); singletonRef_s->bHasServer_     = val; }
-        static void setIsClient     (bool val) { assert(singletonRef_s); singletonRef_s->bIsClient_      = val; }
-
         Settings();
         Settings(const Settings& instance);
@@ -82,8 +68,4 @@
         void setConfigValues();
 
-        bool bShowsGraphics_;                                  //!< global variable that tells whether to show graphics
-        bool bHasServer_;                                      //!< global variable that tells whether this is a server
-        bool bIsClient_;
-
         std::string dataPath_;                                 //!< Path to the game data
 
Index: code/trunk/src/orxonox/gamestates/GSClient.cc
===================================================================
--- code/trunk/src/orxonox/gamestates/GSClient.cc	(revision 1937)
+++ code/trunk/src/orxonox/gamestates/GSClient.cc	(revision 2087)
@@ -32,13 +32,13 @@
 #include "core/input/InputManager.h"
 #include "core/CommandLine.h"
+#include "core/Core.h"
 #include "network/Client.h"
-#include "Settings.h"
 
 namespace orxonox
 {
-    SetCommandLineArgument(ip, "127.0.0.1").setInformation("#.#.#.#");
+    SetCommandLineArgument(ip, "127.0.0.1").information("#.#.#.#");
 
     GSClient::GSClient()
-        : GSLevel("client")
+        : GameState<GSGraphics>("client")
         , client_(0)
     {
@@ -51,26 +51,19 @@
     void GSClient::enter()
     {
-        Settings::_getInstance().bIsClient_ = true;
+        Core::setIsClient(true);
 
-        GSLevel::enter();
-
-        int serverPort = CommandLine::getArgument<int>("port")->getValue();
-        std::string serverIP = CommandLine::getArgument<std::string>("ip")->getValue();
-        this->client_ = new network::Client(serverIP, serverPort);
+        this->client_ = new network::Client(CommandLine::getValue("ip").getString(), CommandLine::getValue("port"));
 
         if(!client_->establishConnection())
             ThrowException(InitialisationFailed, "Could not establish connection with server.");
 
+        GSLevel::enter(this->getParent()->getViewport());
+
         client_->tick(0);
-
-        // level is loaded: we can start capturing the input
-        InputManager::getInstance().requestEnterState("game");
     }
 
     void GSClient::leave()
     {
-        InputManager::getInstance().requestLeaveState("game");
-
-        // TODO: How do we unload the level in client mode?
+        GSLevel::leave();
 
         client_->closeConnection();
@@ -79,7 +72,5 @@
         delete this->client_;
 
-        GSLevel::leave();
-
-        Settings::_getInstance().bIsClient_ = false;
+        Core::setIsClient(false);
     }
 
Index: code/trunk/src/orxonox/gamestates/GSClient.h
===================================================================
--- code/trunk/src/orxonox/gamestates/GSClient.h	(revision 1937)
+++ code/trunk/src/orxonox/gamestates/GSClient.h	(revision 2087)
@@ -33,8 +33,9 @@
 #include "network/NetworkPrereqs.h"
 #include "GSLevel.h"
+#include "GSGraphics.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport GSClient : public GSLevel
+    class _OrxonoxExport GSClient : public GameState<GSGraphics>, public GSLevel
     {
     public:
